﻿#region Copyright
// Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Mime;
using System.Text;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using Syncfusion.Presentation;

namespace Syncfusion.Mvc.Presentation.Web
{
    public class PresentationResult : ActionResult
    {
        private string m_filename;
        private IPresentation m_presentation;
        private FormatType m_formatType;
        private HttpResponse m_response;        

        public string FileName
        {
            get
            {
                return m_filename;
            }
            set
            {
                m_filename = value;
            }
        }
        public IPresentation Presentation
        {
            get
            {
                if (m_presentation != null)
                    return m_presentation;
                return null;
            }
        }
        public FormatType formatType
        {
            get
            {
                return m_formatType;
            }
            set
            {
                m_formatType = value;
            }
        }        
        public HttpResponse Response
        {
            get
            {
                return m_response;
            }
        }

        public PresentationResult(IPresentation presentation, string filename, HttpResponse response)
        {
            FileName = filename;
            m_presentation = presentation;            
            m_response = response;            
        }
        public override void ExecuteResult(ControllerContext context)
        {
            if (context == null)
                throw new ArgumentNullException("Context");
            this.Presentation.Save(FileName,FormatType.Pptx,Response);
        }
    }
}
